#### warning: some of these simulations may take hours to run, caveat lector.

#### options to save data or images are commented out

######################### DF test image

library(MixMatrix)
library(ggplot2)
set.seed(20181102)
df = c(5, 10, 20)
df5 <- rep(0,200)
mean5 <- rep(0,200)
frob5 <- rep(0,200)
df10 <- rep(0,200)
mean10 <- rep(0,200)
frob10 <- rep(0,200)
df100 <- rep(0,200)
mean100 <- rep(0,200)
frob100 <- rep(0,200)
df550 <-  rep(0,200)
mean550 <- rep(0,200)
frob550 <- rep(0,200)
df1050 <-  rep(0,200)
mean1050 <- rep(0,200)
frob1050 <- rep(0,200)
df2050 <- rep(0,200)
mean2050 <- rep(0,200)
frob2050 <- rep(0,200)
df5100 <-  rep(0,200)
mean5100 <- rep(0,200)
frob5100 <- rep(0,200)
df10100 <-  rep(0,200)
mean10100 <- rep(0,200)
frob10100 <- rep(0,200)
df20100 <- rep(0,200)
mean20100 <- rep(0,200)
frob20100 <- rep(0,200)

extractmean <- function(mlobj) sum(mlobj$mean^2)

frobnorm <- function(mlobj) {
    bigmat =  mlobj$var * mlobj$V %x% mlobj$U/(mlobj$nu-2)
    idmat = diag(nrow(bigmat))
    sum((bigmat - idmat)^2)
    }

##### this simulation may take on the order of half an hour
Sys.time()
for(i in 1:200){
    mlobj = MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 5, n = 35, U =3*diag(5), V =diag(3)), fixed = FALSE, df = 5)
    df5[i] = mlobj$nu
    mean5[i] = extractmean(mlobj)
    frob5[i] = frobnorm(mlobj)
    mlobj = MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 10, n = 35, U =8*diag(5), V =diag(3)), fixed = FALSE, df = 10)
  df10[i] = mlobj$nu
    mean10[i] = extractmean(mlobj)
    frob10[i] = frobnorm(mlobj)
    mlobj = MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 20, n = 35, U =18*diag(5), V =diag(3)), fixed = FALSE, df = 20)
  df100[i] =mlobj$nu
    mean100[i] = extractmean(mlobj)
    frob100[i] = frobnorm(mlobj)
    mlobj = MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 5, n = 50, U =3*diag(5), V =diag(3)), fixed = FALSE, df = 5)
    df550[i] = 0+ mlobj$nu
    mean550[i] = extractmean(mlobj)
    frob550[i] = frobnorm(mlobj)
    mlobj = MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 10, n = 50, U =8*diag(5), V =diag(3)), fixed = FALSE, df = 10)
    df1050[i] = 0+ mlobj$nu
    mean1050[i] = extractmean(mlobj)
    frob1050[i] = frobnorm(mlobj)
    mlobj =  MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 20, n = 50, U =18*diag(5), V =diag(3)), fixed = FALSE, df = 20)
    df2050[i] = 0+ mlobj$nu
    mean2050[i] = extractmean(mlobj)
    frob2050[i] = frobnorm(mlobj)
    mlobj = MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 5, n = 100, U =3*diag(5), V =diag(3)), fixed = FALSE, df = 5)
    df5100[i] = 0+ mlobj$nu
    mean5100[i] = extractmean(mlobj)
    frob5100[i] = frobnorm(mlobj)
    mlobj = MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 10, n = 100, U =8*diag(5), V =diag(3)), fixed = FALSE, df = 10)
    df10100[i] = 0+ mlobj$nu
    mean10100[i] = extractmean(mlobj)
    frob10100[i] = frobnorm(mlobj)
    mlobj = MLmatrixt(rmatrixt(mean = matrix(0,5,3),df = 20, n = 100, U =18*diag(5), V =diag(3)), fixed = FALSE, df = 20)
  df20100[i] =  mlobj$nu
    mean20100[i] = extractmean(mlobj)
    frob20100[i] = frobnorm(mlobj)
}
Sys.time()


dfdataframe = data.frame(truedf = factor(rep(rep(c(5,10,20), each = 200),3), label = c('5 df', '10 df', '20 df')),
                         estdf = c(df5, df10, df100, df550, df1050, df2050, df5100, df10100, df20100),
                         samplesize = factor(rep(c(35,50,100), each = 600)))

# dfdataframe = read.csv('degrees-of-freedom.csv')
truedataframe = data.frame(truedf = factor(c(5,10,20), label = c('5 df', '10 df', '20 df')), estdf = c(5,10,20))



library(tidyverse)
dfdataframe$samplesize = factor(dfdataframe$samplesize)
#### if these are in the wrong order:
#dfdataframe$truedf = factor(dfdataframe$truedf,levels(dfdataframe$truedf)[c(3,1,2)])

denseplot <- ggplot(data = subset(dfdataframe, estdf < 110),aes(x=estdf, fill = samplesize, color=samplesize, linetype = samplesize)) +
    geom_density(alpha = .1) +
    geom_vline(data = truedataframe,
               mapping = aes(xintercept = estdf),
               size = .3) +
    theme_bw() +
    theme(axis.ticks.y=element_blank(), axis.text.y=element_blank(), strip.text = element_text(size = 8), 
          legend.justification=c(1,0), legend.position=c(.95,.4),
          legend.background = element_blank(),
          legend.text =element_text(size = 8), legend.title = element_text(size = 8),
          plot.margin=grid::unit(c(0,0,0,0), "mm"),
          strip.background = element_rect(fill="slategray2")) +
#    ggtitle("Density plot of estimated degrees of freedom compared to actual") +
    xlab(NULL) +
    ylab(NULL) +
    scale_linetype_manual(name = "Sample Size", values = c("solid", "dotdash", "dashed")) +
    scale_fill_manual(values = c("#CC79A7","#0072B2", "#D55E00"), name = "Sample Size") +
    scale_color_manual(values = c("#CC79A7","#0072B2", "#D55E00"), name = "Sample Size") +
    facet_wrap(factor(truedf)~.,  scales="free") +
    NULL
denseplot

head(dfdataframe)

#### save image if desired:
# ggsave("dftest.pdf",denseplot, width = 4,height=2.25)

#### save data if desired:
# write.csv(dfdataframe,"degrees-of-freedom.csv")
# dfdataframe <- read.csv("degrees-of-freedom.csv")


library(xtable)
xtable(dfdataframe %>% group_by(truedf, samplesize) %>% summarize(min = min(estdf), max = max(estdf),
                                                           median = median(estdf),
                                                           mean=mean(estdf),
                                                           sd = sd(estdf)))

############## not using this anymore
#pdf("Matrix_Variate_Classification_with_the_t_Distribution_files/figure-latex/dftest-1.pdf",width = 10,height=10)
par(mfrow=c(3,3)) 
hist(df5, xlab = "5 df", main = NULL)
abline(v = 5, col = "blue")
hist(df10, xlab = "10 df", main = NULL)
abline(v = 10, col = "blue")
hist(df100, xlab = "20 df", main = NULL)
abline(v = 20, col = "blue")
hist(df550, xlab = "5 df", main = NULL)
abline(v = 5, col = "blue")
hist(df1050, xlab = "10 df", main = NULL)
abline(v = 10, col = "blue")
hist(df2050, xlab = "20 df", main = NULL)
abline(v = 20, col = "blue")
hist(df5100, xlab = "5 df", main = NULL)
abline(v = 5, col = "blue")
hist(df10100, xlab = "10 df", main = NULL)
abline(v = 10, col = "blue")
hist(df20100, xlab = "20 df", main = NULL)
abline(v = 20, col = "blue")
#dev.off()

#pdf("var-mean.pdf",width = 6.5,height=8)
par(mfrow=c(3,3)) 
hist(sqrt(mean5/15), xlab = "5 df", main = NULL, ylab = "n = 35")
#abline(v = 5, col = "blue")
hist(sqrt(mean10/15), xlab = "10 df", main = NULL, ylab = NULL)
#abline(v = 10, col = "blue")
hist(sqrt(mean100/15), xlab = "20 df", main = NULL, ylab = NULL)
#abline(v = 20, col = "blue")
hist(sqrt(mean550/15), xlab = "5 df", main = NULL, ylab = "n = 50")
#abline(v = 5, col = "blue")
hist(sqrt(mean1050/15), xlab = "10 df", main = NULL, ylab = NULL)
#abline(v = 10, col = "blue")
hist(sqrt(mean2050/15), xlab = "20 df", main = NULL, ylab = NULL)
#abline(v = 20, col = "blue")
hist(sqrt(mean5100/15), xlab = "5 df", main = NULL, ylab = "n = 100")
#abline(v = 5, col = "blue")
hist(sqrt(mean10100/15), xlab = "10 df", main = NULL, ylab = NULL)
#abline(v = 10, col = "blue")
hist(sqrt(mean20100/15), xlab = "20 df", main = NULL, ylab = NULL)
#dev.off()


#pdf("frob.pdf",width = 10,height=10)
par(mfrow=c(3,3)) 
hist(sqrt(frob5)/15, xlab = "5 df", main = NULL, ylab = "n = 35")
#abline(v = 5, col = "blue")
hist(sqrt(frob10)/15, xlab = "10 df", main = NULL, ylab = NULL)
#abline(v = 10, col = "blue")
hist(sqrt(frob100)/15, xlab = "20 df", main = NULL, ylab = NULL)
#abline(v = 20, col = "blue")
hist(sqrt(frob550)/15, xlab = "5 df", main = NULL, ylab = "n = 50")
#abline(v = 5, col = "blue")
hist(sqrt(frob1050)/15, xlab = "10 df", main = NULL, ylab = NULL)
#abline(v = 10, col = "blue")
hist(sqrt(frob2050)/15, xlab = "20 df", main = NULL, ylab = NULL)
#abline(v = 20, col = "blue")
hist(sqrt(frob5100)/15, xlab = "5 df", main = NULL, ylab = "n = 100")
#abline(v = 5, col = "blue")
hist(sqrt(frob10100)/15, xlab = "10 df", main = NULL, ylab = NULL)
#abline(v = 10, col = "blue")
hist(sqrt(frob20100)/15, xlab = "20 df", main = NULL, ylab = NULL)
#dev.off()

frobtable <- tibble(meanRMSE = sqrt(c(mean5, mean10, mean100, mean550, mean1050, mean2050,mean5100,
                             mean10100,mean20100)/15),
                    varRMSE = sqrt(c(frob5, frob10, frob100, frob550, frob1050, frob2050,frob5100,
                                  frob10100,frob20100)/225),
                                n = rep(c(35,50,100),each=600),
                    df = rep(rep(c(5,10,20),each=200),3),
                    pastedf = factor(paste0(df, " df"), levels = c("5 df", "10 df", "20 df")),
                    pasten = factor(paste0("n = ",n), levels = c("n = 35", "n = 50", "n = 100"))
                    )

qplot(meanRMSE, data=frobtable, facets = pasten ~ pastedf) + theme_bw()+ theme( strip.background = element_rect(fill="slategray2"), axis.text.y = element_blank()) + ylab(NULL) + xlab("RMSE of mean estimate")+
       geom_histogram(color="black", fill="#D55E00")
#ggsave("rmse-mean.pdf",width = 4, height = 2.5)

qplot(varRMSE, data=frobtable, facets = pasten ~ pastedf) + theme_bw() + theme( strip.background = element_rect(fill="slategray2"), axis.text.y = element_blank()) + ylab(NULL) + xlab("RMSE of covariance estimate")+
   geom_histogram(color="black", fill="#D55E00")
#ggsave("rmse-var.pdf",width = 4, height = 2.5)

#write.csv(frobtable, "frob-table.csv", row.names = FALSE)
########################### scatterplot
library('scales') 
library('ggplot2')
library('psych')
library('MixMatrix')
library('dplyr')
library('tidyr')
library('cowplot')

######### read in the six sets of data
cor.set1 = read.csv(file =   "Correlationsset1.csv", check.names = FALSE, header = TRUE)[,-1]
cor.set2 = read.csv(file =   "Correlationsset2.csv", check.names = FALSE, header = TRUE)[,-1]
cor.set3 = read.csv(file =   "Correlationsset3.csv", check.names = FALSE, header = TRUE)[,-1]
cor.set4 = read.csv(file =   "Correlations S-10-9-02-truncated.csv", check.names = FALSE, header = TRUE)[,-1]
cor.set5 = read.csv(file =   "Correlations K-9-9-truncated.csv", check.names = FALSE, header = TRUE)[,-1]
cor.set6 = read.csv(file =   "Correlations S-10-9-10-truncated.csv", check.names = FALSE, header = TRUE)[,-1]
                  

totalcorset = rbind(cor.set1,cor.set5, cor.set4, cor.set6)

totalcorset$zfive = fisherz(totalcorset$`5-10`)
totalcorset$zten = fisherz(totalcorset$`10-20`)
totalcorset$repetition = factor(totalcorset$set)
totalcorset$img = factor(totalcorset$img)
matchset = totalcorset[totalcorset$match == "match",]
matchset = droplevels(matchset)
fisher_trans = function() trans_new("fisher", function(x) psych::fisherz(x), 
                                    function(x) psych::fisherz2r(x))

qplot(data = rbind(cor.set1,cor.set5), `5-10`,`10-20`, color = match,shape = match,
      xlab="Cross-correlations in the 5-10 frequency range",
      ylab="Cross-correlations in the 10-20 frequency range", alpha = I(0.25)) + 
      theme_bw() + coord_trans(x = "fisher", y = "fisher") + 
    theme(axis.text.y = element_text(angle = 45, size=7),
          axis.text.x = element_text(angle = 45, hjust = 1, size = 7),
          axis.title=element_text(size=8),
          legend.justification=c(0,1), legend.position=c(0,1),
          legend.background = element_blank(),
          legend.text =element_text(size = 8), legend.title = element_text(size = 8))+
    labs(color = "Class", shape = "Class") + 
    scale_y_continuous(breaks=c(-.2,0,.2,.5,.75,.85,.95))+
    scale_x_continuous(breaks=c(-.25,0,.25,.5,.75,.85,.95,.99))+
    scale_color_manual(values = c("match" = "#FF0000", "nonmatch" = "#0000FF"))+
    NULL
#ggsave('Matrix_Variate_Classification_with_the_t_Distribution_files/figure-latex/loadingone-1.pdf',
#       width = 3, height = 3)



library(ellipse)

pickpoints <- totalcorset$match == 'match'
centers = c(mean(totalcorset[pickpoints,]$zfive),mean(totalcorset[pickpoints,]$zten))
cov = cov(totalcorset[pickpoints,c('zfive','zten')])

#plot(ellipse(centre=centers, cov,level = .95))

ellipsepoints = tanh(ellipse(centre =centers, cov,level = .99, npoints = 300))

centers = c(mean(totalcorset[!pickpoints,]$zfive),mean(totalcorset[!pickpoints,]$zten))
cov = cov(totalcorset[!pickpoints,c('zfive','zten')])
nonmatchellipsepoints = tanh(ellipse(centre =centers, cov,level = .99, npoints = 300))

ellipsedf = data.frame(rbind(ellipsepoints, nonmatchellipsepoints))
ellipsedf$match = rep(c('match','nonmatch'),each = 300)

ellipsedf$x = ellipsedf$zfive
ellipsedf$y = ellipsedf$zten

totalcorset$x = totalcorset$`5-10`
totalcorset$y = totalcorset$`10-20`




### "#050505", "#E69F00", #009E73 56B4E9
library(cowplot)
ellipseplot = ggplot(mapping = aes(x=x, y=y)) +
    geom_point(data = totalcorset, mapping = aes(shape = match, color = match,  alpha = I(0.4)))+
    theme_bw() +
    theme(          legend.justification=c(0,1), legend.position=c(0,1),
          legend.text =element_text(size = 10), legend.title = element_blank(),
          legend.background = element_blank(),
          axis.title = element_text(size = 10),
          axis.text =  element_text(angle = 45,size = 9),
          axis.text.x = element_text( hjust =1)) +
    coord_trans(x = "fisher", y = "fisher") +
    labs(color = "Class", shape = "Class", x="Cross-correlations in 5-10 frequency range",
         y="Cross-correlations in 10-20 frequency range" ) + 
    geom_path(data = subset(ellipsedf, match == "match"), aes(x = x, y = y), linetype = 2, size = 1, color = c("#DAA520")) +
    geom_path(data = subset(ellipsedf, match == "nonmatch"), aes(x = x, y = y), linetype = 2, size = 1, color = c("#0000FF"))+
    scale_y_continuous(breaks = c(-.15,0,.25,.5,.75,.90,.95,.99)) +
    scale_x_continuous(breaks = c(-.25,0,.25,.5,.75,.90,.95,.99)) +
    scale_color_manual(values = c("match" = "#E69F00", "nonmatch" = "#56B4E9"))+
  NULL
ellipseplot

xdens <- axis_canvas(ellipseplot, axis = 'x') + 
  geom_density(data = totalcorset, mapping = aes(x = (x),color = match,  alpha = I(0.4))) +
   scale_color_manual(values = c("match" = "#E69F00", "nonmatch" = "#0000FF"))+
  scale_x_continuous(trans = "fisher") +
    geom_histogram(data = totalcorset, mapping = aes(x = (x), y = ..density.., fill = match,  alpha = I(0.4)), position = 'identity')+
       scale_fill_manual(values = c("match" = "#E69F00", "nonmatch" = "#56B4E9"))
ydens <- axis_canvas(ellipseplot, axis = 'y', coord_flip = TRUE) + 
  geom_density(data = totalcorset, mapping = aes(x = (y), color = match,  alpha = I(0.4))) +
   scale_color_manual(values = c("match" = "#E69F00", "nonmatch" = "#0000FF"))+
  scale_x_continuous(trans = "fisher") +
    geom_histogram(data = totalcorset, mapping = aes(x = (y), y = ..density.., fill = match,  alpha = I(0.4)), position = 'identity') +
       scale_fill_manual(values = c("match" = "#E69F00", "nonmatch" = "#56B4E9"))+
  coord_flip()
p1 <- insert_xaxis_grob(ellipseplot, xdens, grid::unit(.2, 'null'), position = "top")
p2 <- insert_yaxis_grob(p1, ydens, grid::unit(.2, 'null'), position = 'right')
ggdraw(p2)

#ggsave('loadingone-1.pdf',p2,       width = 4, height = 4)


############################### classification results
logodds_new_data <- function(data, object, prior = object$prior, ...){
  #invlogit = function(x) exp(x)/(1+exp(x))
  logit = function(x) log((1-x)/(x))
  logit(predict(object, newdata=data, prior, ...)$posterior[,2])
}



keep.vars = c("knife","img","match","zfive","zten","repetition")
corset.shaped = reshape(totalcorset[,keep.vars], idvar = c("knife","match","repetition"), timevar = "img", direction = "wide")
dims = dim(corset.shaped)
matrix(unlist((corset.shaped[,4:21])))
knifearray = aperm(array(t(unlist(corset.shaped[,4:21])), dim = c(dims[1],2,9)),c(2,3,1))

matchlabels = corset.shaped$match[corset.shaped$repetition == "1"]

matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "1"], 
                      matchlabels, prior = c(.5,.5), method = 'normal',
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)

plotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "1",
                      model = "Normal")


matchlabels = corset.shaped$match[corset.shaped$repetition == "K-9-9-01"]

matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "K-9-9-01"], 
                      matchlabels, prior = c(.5,.5), method = 'normal',
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)




addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "K-9-9-01",
                      model = "Normal")
plotdf = rbind(plotdf, addplotdf)


matchlabels = corset.shaped$match[corset.shaped$repetition == "S-10-9-10-01"]

matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "S-10-9-10-01"], 
                      matchlabels, prior = c(.5,.5), method = 'normal',
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)


addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "S-10-9-10-01",
                      model = "Normal")
plotdf = rbind(plotdf, addplotdf)


 

matchlabels = corset.shaped$match[corset.shaped$repetition == "S-10-09-02-01"]

matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "S-10-09-02-01"], 
                      matchlabels, prior = c(.5,.5), method = 'normal',
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)



addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "S-10-09-02-01",
                      model = "Normal")
plotdf = rbind(plotdf, addplotdf)

###### second thing
df = 5

matchlabels = corset.shaped$match[corset.shaped$repetition == "1"]


matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "1"], 
                      matchlabels, prior = c(.5,.5), method = 't', nu = df,
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)



addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "1",
                      model = "t: 5 df")
plotdf = rbind(plotdf, addplotdf)


matchlabels = corset.shaped$match[corset.shaped$repetition == "K-9-9-01"]


matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "K-9-9-01"], 
                      matchlabels, prior = c(.5,.5), method = 't', nu = df,
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)


addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "K-9-9-01",
                      model = "t: 5 df")
plotdf = rbind(plotdf, addplotdf)


matchlabels = corset.shaped$match[corset.shaped$repetition == "S-10-9-10-01"]

matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "S-10-9-10-01"], 
                      matchlabels, prior = c(.5,.5), method = 't', nu = df,
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)

addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "S-10-9-10-01",
                      model = "t: 5 df")
plotdf = rbind(plotdf, addplotdf)


matchlabels = corset.shaped$match[corset.shaped$repetition == "S-10-09-02-01"]


matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "S-10-09-02-01"], 
                      matchlabels, prior = c(.5,.5), method = 't', nu = df,
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)


addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "S-10-09-02-01",
                      model = "t: 5 df")
plotdf = rbind(plotdf, addplotdf)


###### third thing
df = 10

matchlabels = corset.shaped$match[corset.shaped$repetition == "1"]


matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "1"], 
                      matchlabels, prior = c(.5,.5), method = 't', nu = df,
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)



addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "1",
                      model = "t: 10 df")
plotdf = rbind(plotdf, addplotdf)


matchlabels = corset.shaped$match[corset.shaped$repetition == "K-9-9-01"]


matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "K-9-9-01"], 
                      matchlabels, prior = c(.5,.5), method = 't', nu = df,
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)


addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "K-9-9-01",
                      model = "t: 10 df")
plotdf = rbind(plotdf, addplotdf)


matchlabels = corset.shaped$match[corset.shaped$repetition == "S-10-9-10-01"]

matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "S-10-9-10-01"], 
                      matchlabels, prior = c(.5,.5), method = 't', nu = df,
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)

addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "S-10-9-10-01",
                      model = "t: 10 df")
plotdf = rbind(plotdf, addplotdf)


matchlabels = corset.shaped$match[corset.shaped$repetition == "S-10-09-02-01"]


matching.fit = matrixqda(knifearray[,,corset.shaped$repetition == "S-10-09-02-01"], 
                      matchlabels, prior = c(.5,.5), method = 't', nu = df,
                     row.mean = TRUE, col.variance = "AR(1)")

classes = logodds_new_data(knifearray, matching.fit)


addplotdf = data.frame(match = corset.shaped$match, 
                      set = corset.shaped$repetition, 
                      classes = classes,
                      train = "S-10-09-02-01",
                      model = "t: 10 df")
plotdf = rbind(plotdf, addplotdf)





newsetlabels = c("1" = "Set 1 (9)", "K-9-9-01" = "Set 2 (9)", "S-10-9-10-01" = "Set 4 (10)",
                 "S-10-09-02-01" = "Set 3 (10)")
plotdf$train = factor(plotdf$train, labels = c("Set 1 (9)","Set 2 (9)", "Set 3 (10)", "Set 4 (10)"))

#write.csv(plotdf,"logodds.csv")
#plotdf <- read.csv("../logodds.csv")


postlogplot <- ggplot(data = plotdf, aes(x = match, y = classes/log(10), fill = train)) +
  labs(x = NULL, 
       y = "log-odds (base 10)") +
    theme_bw() +
    theme(title = element_text(size = 9), legend.position="bottom", legend.text = element_text(size=7),
          legend.title = element_text(size = 8), axis.text =  element_text(size=7), axis.title = element_text(size=8),
          axis.text.y = element_text( angle = 90, hjust = .5),
          strip.text = element_text(size = 7), plot.margin=grid::unit(c(0,0,0,0), "mm"),
          strip.background = element_rect(fill = "slategray2"))+
    geom_boxplot() +
    scale_fill_manual(values = c("#999999", "#E69F00", "#56B4E9", "#009E73"), name = NULL)+
    geom_hline(yintercept = 0) +
    facet_wrap(~model, scales = "free") +
    NULL
postlogplot

#ggsave('matnorm-1.pdf',       plot = postlogplot, width = 3.6, height = 2.5)



####### FMRI picture

########## this is not what is used
load('fmri-mask.rda')
load('zstat-LRH.rda')
 imgone <- (zstat.LH[,,20,1]+ 8) * slicemask
 imgtwo <- (zstat.RH[,,20,1]+ 8) * slicemask

#png('brain-example.png', width = 256, height = 128, units = 'px')
 par(mfrow=c(1,2), mar = c(0,0,0,0))
 image(imgone, axes = FALSE, col = gray(0:12/12), useRaster = TRUE)
 image(imgtwo, axes = FALSE, col = gray(0:12/12), useRaster = TRUE)
# dev.off()


#######################################
#### timing study
#### WARNING: this may take a few hours

library(microbenchmark)
set.seed(20191002)
A <- rmatrixt(100, mean = matrix(0, nrow=5, ncol = 5), df = 5)
B <- rmatrixt(100, mean = matrix(0, nrow=5, ncol = 25), df = 5)
C <- rmatrixt(100, mean = matrix(0, nrow=25, ncol = 5), df = 5)
D <- rmatrixt(100, mean = matrix(0, nrow=25, ncol = 25), df = 5)
CC <- rmatrixt(100, mean = matrix(0, nrow=100, ncol = 5), df = 5)
BB <- rmatrixt(100, mean = matrix(0, nrow =5, ncol = 100), df = 5)
AA <- rmatrixt(100, mean = matrix(0, nrow =25, ncol = 100), df = 5)
DD <-  rmatrixt(100, mean = matrix(0, nrow = 100, ncol = 25), df = 5)
DDD <- rmatrixt(100, mean = matrix(0, nrow = 100, ncol = 100), df = 5)
E <- rmatrixt(500, mean = matrix(0, nrow=5, ncol = 5), df = 5)
F <- rmatrixt(500, mean = matrix(0, nrow=5, ncol = 25), df = 5)
G <- rmatrixt(500, mean = matrix(0, nrow=25, ncol = 5), df = 5)
H <- rmatrixt(500, mean = matrix(0, nrow=25, ncol = 25), df = 5)
GG <- rmatrixt(500, mean = matrix(0, nrow = 100, ncol = 5), df = 5)
FF <- rmatrixt(500, mean = matrix(0, nrow = 5, ncol = 100), df = 5)
EE <- rmatrixt(500, mean = matrix(0, nrow = 100, ncol = 25), df = 5)
HH <-rmatrixt(500, mean = matrix(0, nrow = 25, ncol = 100), df = 5)
HHH <- rmatrixt(500, mean = matrix(0, nrow = 100, ncol = 100), df = 5)



timingexpnu <- microbenchmark(
    MLmatrixt(A, df = 5, fixed = FALSE),
    MLmatrixt(B, df = 5, fixed = FALSE),
    MLmatrixt(C, df = 5, fixed = FALSE),
    MLmatrixt(D, df = 5, fixed = FALSE),
    MLmatrixt(CC, df = 5, fixed = FALSE),
    MLmatrixt(BB, df = 5, fixed = FALSE),
    MLmatrixt(AA, df = 5, fixed = FALSE),
    MLmatrixt(DD, df = 5, fixed = FALSE),
    MLmatrixt(DDD, df = 5, fixed = FALSE),
    MLmatrixt(E, df = 5, fixed = FALSE),
    MLmatrixt(F, df = 5, fixed = FALSE),
    MLmatrixt(G, df = 5, fixed = FALSE),
    MLmatrixt(H, df = 5, fixed = FALSE),
    MLmatrixt(GG, df = 5, fixed = FALSE),
    MLmatrixt(FF, df = 5, fixed = FALSE),
    MLmatrixt(EE, df = 5, fixed = FALSE),
    MLmatrixt(HH, df = 5, fixed = FALSE),
    MLmatrixt(HHH, df = 5, fixed = FALSE),
    times = 100
)
#write.csv(timingexpnu, "timing-nu.csv")
#timingexpnu <- read.csv("timing-nu.csv")

xlabels = c("n = 100, p = 5, q = 5",
            "n = 100, p = 5, q = 25",
            "n = 100, p = 25, q = 5",
            "n = 100, p = 25, q = 25",
            "n = 100, p = 100, q = 5",
            "n = 100, p = 5, q = 100",
            "n = 100, p = 25, q = 100",
            "n = 100, p = 100, q = 25",
            "n = 100, p = 100, q = 100",
            "n = 500, p = 5, q = 5",
            "n = 500, p = 5, q = 25",
            "n = 500, p = 25, q = 5",
            "n = 500, p = 25, q = 25",
            "n = 500, p = 100, q = 5",
            "n = 500, p = 5, q = 100",
            "n = 500, p = 100, q = 25",
            "n = 500, p = 25, q = 100",
            "n = 500, p = 100, q = 100"
            )



timenugraph <- autoplot(timingexpnu) + theme_bw()+ theme_bw() + scale_x_discrete(labels = xlabels) + xlab(NULL)
#ggsave("timing-nu.pdf", timenugraph, height = 4, width = 6)

#ifelse(grepl("n = 100,", xlabels), 100, 500)
#ifelse(grepl("p = 5", xlabels), 5, ifelse(grepl("p = 25", xlabels), 25, 100))
#ifelse(grepl("q = 5", xlabels), 5, ifelse(grepl("q = 25", xlabels), 25, 100))

#timingdf = timingexp
#levels(timingdf$expr) = xlabels
#timingdf$n = ifelse(grepl("n = 100,", timingdf$expr), 100, 500)
#timingdf$p = ifelse(grepl("p = 5",  timingdf$expr), 5, ifelse(grepl("p = 25",  timingdf$expr), 25, 100))
#timingdf$q = ifelse(grepl("q = 5",  timingdf$expr), 5, ifelse(grepl("q = 25",  timingdf$expr), 25, 100))

timingnudf = timingexpnu
levels(timingnudf$expr) = xlabels
timingnudf$n = ifelse(grepl("n = 100,", timingnudf$expr), 100, 500)
timingnudf$p = ifelse(grepl("p = 5",  timingnudf$expr), 5, ifelse(grepl("p = 25",  timingnudf$expr), 25, 100))
timingnudf$q = ifelse(grepl("q = 5",  timingnudf$expr), 5, ifelse(grepl("q = 25",  timingnudf$expr), 25, 100))

timingnudf$n = factor(timingnudf$n)
timingnudf$q = factor(timingnudf$q)
timingnudf$p = factor(timingnudf$p)

 ggplot(timingnudf, aes(x = q, y = time/1e9, fill =n )) +
     scale_y_log10() +
     #scale_x_discrete(limits = rev(levels(timingnudf$q)))+
     #geom_split_violin() +
     geom_violin(scale=3.75, size = .2)+
    xlab("Column dimension")+
     ylab("Time [Sec]") +
     labs(fill = "N")+
     geom_vline(xintercept = c(1.5,2.5),color="gray") +
     facet_grid(.~p, labeller = as_labeller(c(`5` = "5 rows",
                                              `25` = "25 rows",
                                              `100` = "100 rows")))+
     theme_bw()+
     theme( #legend.position = "bottom",
          legend.background = element_blank(),
         legend.justification=c(1,0), legend.position=c(1,0),
         legend.key.size = unit(.25,"cm"),
            strip.background = element_rect(fill="slategray2"))+
     scale_fill_brewer(palette = "Paired")+
     NULL

#ggsave("timing-violin-plot.pdf", height = 2.5, width=4)


### supplemental  study

set.seed(20191011)


extractmean <- function(mlobj) sum(mlobj$mean^2)

frobnorm <- function(mlobj) {
    bigmat =  mlobj$var * mlobj$V %x% mlobj$U/(mlobj$nu-2)
    idmat = diag(nrow(bigmat))
    sum((bigmat - idmat)^2)
}

frobvalue <- function(mlobj, U, V, df){
    if(is.null(mlobj$nu)){
        bigmat =  mlobj$var * mlobj$V %x% mlobj$U
    } else {
        bigmat =  mlobj$var * mlobj$V %x% mlobj$U/(mlobj$nu-2)
    }
    if(df > 2) {
        idmat = V %x% U / (df-2)
    } else idmat = V %x% U
    
    sum((bigmat - idmat)^2)
}

U = toeplitz(.7^(0:4))
V = rWishart(1,df = 10, Sigma = diag(8))[,,1]

sampledata <- rmatrixt(100,6, mean = matrix(0,5,8), U = U, V = V)
twosampledata <- rmatrixt(100,20, mean = matrix(0,5,8), U = U, V = V)
normsampledata <- rmatrixnorm(100, mean = matrix(0,5,8), U = U, V = V)

getLL = function(mlobj) tail(mlobj$logLik, 1)

dfstotry = c(0,3:100)
loglikvector = rep(0,99)
meanvector = rep(0,99)
frobvector = rep(0,99)

for(i in 1:99){
    fitmodel = MLmatrixt(sampledata, df = dfstotry[i])
    loglikvector[i] = getLL(fitmodel)
    meanvector[i] = extractmean(fitmodel)
    frobvector[i] = frobvalue(fitmodel, U, V, 6)
}

ttibble <- tibble(df = dfstotry, logLik = loglikvector,
                  meanRMSE = meanvector, varRMSE = frobvector)
ttibble$model = "t 6df"

twologlikvector = rep(0,99)
twomeanvector = rep(0,99)
twofrobvector = rep(0,99)

for(i in 1:99){
    fitmodel = MLmatrixt(twosampledata, df = dfstotry[i])
    twologlikvector[i] = getLL(fitmodel)
    twomeanvector[i] = extractmean(fitmodel)
    twofrobvector[i] = frobvalue(fitmodel, U, V, 20)
}

ttwotibble <- tibble(df = dfstotry, logLik = twologlikvector,
                  meanRMSE = twomeanvector, varRMSE = twofrobvector)
ttwotibble$model = "t 20df"


normloglikvector = rep(0,99)
normmeanvector = rep(0,99)
normfrobvector = rep(0,99)
for(i in 1:99){
    fitmodel = MLmatrixt(normsampledata, df = dfstotry[i])
    normloglikvector[i] = getLL(fitmodel)
    normmeanvector[i] = extractmean(fitmodel)
    normfrobvector[i] = frobvalue(fitmodel, U, V, 0)
}

normtibble <- tibble(df = dfstotry, logLik = normloglikvector,
                       meanRMSE = normmeanvector, varRMSE = normfrobvector)
normtibble$model = "norm"

#png("simulation-efficacy.png", width = 6, height = 4, res = 300, units = "in")
#pdf("simulation-efficacy.pdf",width=4, height = 4)
par(mfrow = c(3,3) ,cex=0.5,oma = c(.1 ,.1, .1, 0.1), mar=c(1, 3, 2.5, .2),
    mgp=c(2,1,0))
plot(dfstotry,loglikvector, xlab = "", main = "Log Likelihood",
     ylab = '6 degrees of freedom',font.lab=2,pch=20, col = "#666666")
abline(v=6, col = "blue", lty = 2)
text(dfstotry[1],loglikvector[1],labels = "Normal", pos=4, col = "darkred", font = 2)
plot(dfstotry,meanvector, xlab = "", main = "Squared dev. of Mean",ylab = '',
     pch=20,  col = "#666666")
abline(v=6, col = "blue", lty = 2)
text(dfstotry[1],meanvector[1],labels = "Normal", pos=4, col = "darkred", font = 2)
plot(dfstotry,sqrt(frobvector), xlab = "", main = "L2 norm of covariance",
     ylab = '',pch=20,  col = "#666666")
abline(v=6, col = "blue", lty = 2)
text(dfstotry[1],sqrt(frobvector)[1],labels = "Normal", pos=4, col = "darkred", font = 2)
plot(dfstotry,twologlikvector, xlab = "",
     ylab = '20 degrees of freedom',font.lab = 2,
     pch=20,  col = "#666666")
abline(v=20, col = "blue", lty = 2)
text(dfstotry[1],twologlikvector[1],labels = "Normal", pos=4, col = "darkred", font = 2)
plot(dfstotry,twomeanvector, xlab = "", ylab = '',
     pch=20,  col = "#666666")
abline(v=20, col = "blue", lty = 2)
text(dfstotry[1],twomeanvector[1],labels = "Normal", pos=4, col = "darkred", font = 2)
plot(dfstotry,sqrt(twofrobvector), xlab = "", ylab ='',
     pch=20,  col = "#666666")
abline(v=20, col = "blue", lty = 2)
text(dfstotry[1],sqrt(twofrobvector)[1],labels = "Normal", pos=4, col = "darkred", font = 2)
par( mar=c(3, 3, 2.5, .2))
plot(dfstotry,normloglikvector, xlab = "Degrees of freedom", ylab = 'Normal', font.lab = 2,
     pch=20,  col = "#666666")
text(dfstotry[1],normloglikvector[1],labels = "Normal", pos=4, col = "darkred", font = 2)
plot(dfstotry,normmeanvector, xlab = "Degrees of freedom", ylab ='',font.lab = 2,
     pch=20,  col = "#666666")
text(dfstotry[1],normmeanvector[1],labels = "Normal", pos=4, col = "darkred", font = 2)
plot(dfstotry,sqrt(normfrobvector), xlab = "Degrees of freedom", ylab = '',font.lab = 2,
     pch=20,  col = "#666666")
text(dfstotry[1],sqrt(normfrobvector)[1],labels = "Normal", pos=4, col = "darkred", font = 2)
#dev.off()

totaltibble <- rbind(normtibble, ttwotibble, ttibble)
#write.csv(totaltibble,"convergence-diag.csv")
